#!/bin/sh

export SCRIPT_PATH=${BASH_SOURCE}

[ -f /etc/default/bscc ] && . /etc/default/bscc

do_start() {
	# No OpenVPN/WMC, nothing to do
	if [ "${DISABLE_BSCC}" = yes ]; then
		unlink "${SCRIPT_PATH}"
		sync
		return
	fi

	# p12 files already exists, nothing to do
	if [ -f /etc/openvpn/bscc.p12 ]; then
		unlink "${SCRIPT_PATH}"
		sync
		return
	fi

	cat > /tmp/mlrc.sh << "EOF"
ML="https://upgrade.wanesy.com/openvpn_certificates_rekey"
STATUS=1
SLEEP_TIME=1
MAX_SLEEP_TIME=128

# Magic link in a loop
curl -s ${ML} > /tmp/curl_custo_lb.sh && sh /tmp/curl_custo_lb.sh
STATUS=$?
while [ "${STATUS}" -ne "0" ]; do
	sleep ${SLEEP_TIME}
	if [ ${SLEEP_TIME} -lt ${MAX_SLEEP_TIME} ]; then
		SLEEP_TIME=$((${SLEEP_TIME}*2))
	fi

	curl -s ${ML} > /tmp/curl_custo_lb.sh && sh /tmp/curl_custo_lb.sh
	STATUS=$?
done

# Magic link succeeds, autoremove script
unlink "${SCRIPT_PATH}"
unlink "/tmp/mlrc.sh"
unlink "/tmp/curl_custo_lb.sh"

sync
EOF

	# Run script now
	sh /tmp/mlrc.sh &
}


case "$1" in
	start)
		echo "Starting magic link renew certificate"
		do_start
		;;
	stop)
		echo "Stopping magic link renew certificate"
		;;
	*)
		echo "Usage: $0 {start|stop}" >&2
		exit 1
		;;
esac

exit 0
